/*
 * this is a nasty hack to alter display on all opengl programmes
 * you must put the full path of the compiled binary in the
 * in the LD_PRELOAD env variable
 * (export LD_PRELOAD="/path/to/the/binary.so")
 * 
 * Req : XFree / LD_PRELOAD compatible os (linux + ?)
 * tested with mesa
 * 
 * 
 * some code parts comme from : 
 * http://www.gametutorials.com/Tutorials/opengl/OpenGL_Pg1.htm
 * http://www.opengl.org/developers/code/features/fontsurvey/
 */


#define __USE_GNU 1

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <dlfcn.h>
#include <time.h>

#include <sys/types.h>
#include <sys/stat.h>

#include <X11/X.h>
#include <X11/Xlib.h>

#include <GL/gl.h>
#include <GL/glx.h>

#include "gla.h"
#include "o_funcs.h"
#include "light.h"

#define RTLD_NEXT  ((void *) -1l)
#define FONT_NAME "fixed"

#define FILTERS_MAX 1

#define SAVE_STATE		1
#define RESTORE_STATE	0

extern int grab;
extern int fps_on;
extern int lights_on[GL_MAX_LIGHTS];
extern int recording_on;
extern double ortho[6];

extern void display_menu();
extern void display_fps();
extern void display_fog();
extern void display_snow();
extern void display_rain();
extern void write_ppmfile();
void perspective_mode();
void ortho_mode();

static GLuint font_base;

static GLenum saved_mmode;

typedef struct {
	int force_state;
	int saved_state;
	GLenum value;
} EnableFilter;

EnableFilter filter[]={
	{0, 0, GL_FOG},
	{0, 0, GL_LIGHT0},
	{0, 0, GL_LIGHT1},
	{0, 0, GL_LIGHT2},
	{0, 0, GL_LIGHT3},
	{0, 0, GL_LIGHT4},
	{0, 0, GL_LIGHT5},
	{0, 0, GL_LIGHT6},
	{0, 0, GL_LIGHT7},
	{0,0,0}
};

typedef struct {
	int *var;
	void (*function)(int *var);
}Taskinfo;

int allways_true=1;

Taskinfo task[] = {
	{&snow_on,&display_snow},
	{&rain_on,&display_rain},
	{&allways_true,&ortho_mode},
	{&fog_on,&display_fog},
	{&fps_on,&display_fps},
	{&recording_on, &write_ppmfile},
	{&grab,&display_menu},
	{lights_on, &display_light},
	{lights_on+1, &display_light},
	{lights_on+2, &display_light},
	{lights_on+3, &display_light},
	{lights_on+4, &display_light},
	{lights_on+5, &display_light},
	{lights_on+6, &display_light},
	{lights_on+7, &display_light},
	{&allways_true,&perspective_mode},
	{NULL,NULL}
};


void gla_nothing(void){}

const glFunc gla_glfuncs[] = {
	{"glXMakeCurrent",	(void**)(&o_glXMakeCurrent)	},
	{"glXSwapBuffers",	(void**)(&o_glXSwapBuffers)	},
	{"glLoadIdentity",	(void**)(&o_glLoadIdentity)	},
	{"glEnable",		(void**)(&o_glEnable)},
	{"glDisable",		(void**)(&o_glDisable)},
	{"glPolygonMode",	(void**)(&o_glPolygonMode)},
	{"glOrtho",		(void**)(&o_glOrtho)},
	
	{"glVertex2d",		(void**)(&o_glVertex2d)},
	{"glVertex2f",		(void**)(&o_glVertex2f)},
	{"glVertex2i",		(void**)(&o_glVertex2i)},
	{"glVertex2s",		(void**)(&o_glVertex2s)},
	{"glVertex3d",		(void**)(&o_glVertex3d)},
	{"glVertex3f",		(void**)(&o_glVertex3f)},
	{"glVertex3i",		(void**)(&o_glVertex3i)},
	{"glVertex3s",		(void**)(&o_glVertex3s)},
	{"glVertex4d",		(void**)(&o_glVertex4d)},
	{"glVertex4f",		(void**)(&o_glVertex4f)},
	{"glVertex4i",		(void**)(&o_glVertex4i)},
	{"glVertex4s",		(void**)(&o_glVertex4s)},
/*	{"glVertex2dv",		(void**)(&o_glVertex2dv)},
	{"glVertex2fv",		(void**)(&o_glVertex2fv)},
	{"glVertex2iv",		(void**)(&o_glVertex2iv)},
	{"glVertex2sv",		(void**)(&o_glVertex2sv)},
	{"glVertex3dv",		(void**)(&o_glVertex3dv)},
	{"glVertex3fv",		(void**)(&o_glVertex3fv)},
	{"glVertex3iv",		(void**)(&o_glVertex3iv)},
	{"glVertex3sv",		(void**)(&o_glVertex3sv)},
	{"glVertex4dv",		(void**)(&o_glVertex4dv)},
	{"glVertex4fv",		(void**)(&o_glVertex4fv)},
	{"glVertex4iv",		(void**)(&o_glVertex4iv)},
	{"glVertex4sv",		(void**)(&o_glVertex4sv)},
*/
	{"XNextEvent",		(void**)(&o_XNextEvent)},
	{"XPeekEvent",		(void**)(&o_XPeekEvent)},
	{"XWindowEvent",	(void**)(&o_XWindowEvent)},
	{"XMaskEvent",		(void**)(&o_XMaskEvent)},
	{"XCheckMaskEvent",	(void**)(&o_XCheckMaskEvent)},
	{"XCheckTypedEvent",(void**)(&o_XCheckTypedEvent)},
	{"XCheckTypedWindowEvent",(void**)(&o_XCheckTypedWindowEvent)},
	{"XIfEvent",		(void**)(&o_XIfEvent)},
	{"XCheckIfEvent",	(void**)(&o_XCheckIfEvent)},
	{"XPeekIfEvent",	(void**)(&o_XPeekIfEvent)},
	{"XEventsQueued",	(void**)(&o_XEventsQueued)},
	{"XPending",		(void**)(&o_XPending)},

	{NULL,			NULL}
};

int is_filtered(GLenum cap) {
	int i;
	for (i=0; filter[i].value; i++)
		if (filter[i].value==cap && filter[i].force_state)
			return 1;
	return 0;
}

void glEnable(GLenum cap) {
	if (!is_filtered(cap))
		o_glEnable(cap);
}

void glDisable(GLenum cap) {
	if (!is_filtered(cap))
		o_glDisable(cap);
}

void set_filter(int index, int state) {
	filter[index].force_state=state;
}

static void getWindowSize() {
	static XWindowAttributes attr;
	if (!XGetWindowAttributes(win.dpy,win.drawable, &attr)) {
		printf("invalid attr\n");
	} else {
		win.x=attr.width;
		win.y=attr.height;
	}
}

int _init(void)
{
	const glFunc *p;

	win.has_context=0;

	set_defeffect_params(getenv("GLA_DEFORM_EFFECTS"));

	for(p=gla_glfuncs; p->name!=NULL && p->cb!=NULL; p++) {
		*(p->cb) = dlsym(RTLD_NEXT, p->name);
		if(! *(p->cb) ) {
			*(p->cb) = (void*)gla_nothing;
			fprintf(stderr, "WARNING: unable to find symbol for function %s\n", p->name);
		}
	}
	init_menu();
	init_parts();
	
	return 0;
}


static void init_font(Display *dpy, GLuint base, char* f)
{
   XFontStruct* font_info;
   int first;
   int last;

	/* Load the font. */
	font_info = XLoadQueryFont(dpy, f);
	if (!font_info) {
		fprintf(stderr, "XLoadQueryFont() failed - Exiting.\n");
		abort();
	} else {
		/* Tell GLX which font & glyphs to use. */
		first = font_info->min_char_or_byte2;
		last  = font_info->max_char_or_byte2;
		glXUseXFont(font_info->fid, first, last-first+1, base+first);
	}
}


static void init_gl(Display *dpy)
{
	font_base = glGenLists(256);
	if (!glIsList(font_base)) {
		fprintf(stderr, "glhack: Out of display lists. - Exiting.\n");
		abort();
	} else {
		init_font(dpy,font_base, FONT_NAME);
	}
	printf("display list created\n");
}

/*
 * ortho mode for 2D display & osd
 */
static void ortho_mode()
{
	glGetIntegerv(GL_MATRIX_MODE,&saved_mmode);
    glMatrixMode(GL_PROJECTION);
    glPushMatrix();
    glLoadIdentity();
    glOrtho( 0, win.x, 0, win.y, 0, 64 );
    glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
    glLoadIdentity();

	glRasterPos2f(0.0,0.0);
}


/* restore previous mode */
static void perspective_mode()
{
	glPopMatrix();
    glMatrixMode( GL_PROJECTION );
    glPopMatrix();
    glMatrixMode(saved_mmode);
}


void print_string(char* s)
{
   if (!glIsList(font_base)) {
      fprintf(stderr, "print_string(): Bad display list. - Exiting.\n");
      abort();
   }
   else if (s && strlen(s)) {
      glPushAttrib(GL_LIST_BIT);
      glListBase(font_base);
      glCallLists(strlen(s), GL_UNSIGNED_BYTE, (GLubyte *)s);
      glPopAttrib();
   }
}

Bool glXMakeCurrent(Display *dpy, GLXDrawable drawable, GLXContext ctx)
{
	Bool ret;
	win.dpy=dpy;
	win.drawable=drawable;

	ret = o_glXMakeCurrent(dpy,drawable,ctx);
	if (! win.has_context) {
		printf("gla... running\nnew opengl context detected\n");
		init_gl(dpy);
		win.has_context=GL_TRUE;
	}
	return ret;
}


void taskrun() {
	int i;
	for (i=0; task[i].var!=NULL ;i++) {
		if (*(task[i].var))
			task[i].function(task[i].var);
	}
}

unsigned long update_time() {
	static int first=1;
	static struct timeval new;
	static struct timeval old;
	static struct timezone tz;
	static long ret;
	if (gettimeofday(&new, &tz))
		perror("gettimeofday");
	ret=(long) ((new.tv_sec-old.tv_sec)*1000 +
		(new.tv_usec - old.tv_usec)/ 1000);
	old.tv_sec=new.tv_sec;
	old.tv_usec=new.tv_usec;
	if (! first)
		return ret;
	else {
		first=0;
		return 0;
	}
	
}

static void state_memory(int save) {
	static GLboolean restore_light;
	static GLboolean restore_texture_2d;
	static GLint restore_texture_name;
	static GLfloat restore_color[4];
	static GLfloat restore_point_size;
	

	if (save) {
		glGetBooleanv(GL_LIGHTING,&restore_light);
		glGetBooleanv(GL_TEXTURE_2D,&restore_texture_2d);
		glGetFloatv(GL_CURRENT_COLOR,restore_color);
		glGetFloatv(GL_POINT_SIZE,&restore_point_size);
		
		glPointSize(2.0);
		if (restore_light)
			glDisable(GL_LIGHTING);
        if (restore_texture_2d) {
			glGetIntegerv(GL_TEXTURE_BINDING_2D, &restore_texture_name);
			glDisable(GL_TEXTURE_2D);
		}
		
	} else {
		glColor4fv(restore_color);
		glPointSize(restore_point_size);
		if (restore_light)
			glEnable(GL_LIGHTING);
		if (restore_texture_2d) {
			glEnable(GL_TEXTURE_2D);
			glBindTexture(GL_TEXTURE_2D, restore_texture_name);
		}
		
	}	
}



void glXSwapBuffers(Display *dpy, GLXDrawable drawable)
{

	getWindowSize();

	if (!glIsList(font_base)) {
		fprintf(stderr, "print_string(): Bad display list. - Exiting.\n");
		abort();
	}
	cleanQueue(dpy);
	state_memory(SAVE_STATE);
	win.frametime=update_time();
	glColor4f(1.0f,0.0f,0.0f,1.0f);
	taskrun();

	state_memory(RESTORE_STATE);
	o_glXSwapBuffers(dpy, drawable);
}


int _fini(void) {
	return 0;
}

