#include <stdio.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>

#include <GL/gl.h>
#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/keysym.h>

#include "gla.h"


#define MENU		0
#define LASTMENU	1
#define CHECKBOX	2
#define TRIPLESTATE	3
#define OPTIONBOX	4
#define INT			5
#define FLOAT		6
#define COORDS		7
#define RGB			8

typedef struct {
	char *name;
	int lvl;
	void *(*run)();
	int type;
	char key;
} menutree;

extern int grab;
extern void switch_fps();
extern void switch_fog();
extern void switch_snow();
extern void switch_rain();
extern void switch_recording();
extern void set_polymode();

extern float *fog_color(GLfloat color[]);
extern float *fog_density_func(GLfloat *density);
extern float *fog_start_func(GLfloat *start);
extern float *fog_end_func(GLfloat *end);

int currmenu=-1;
int active_color=-1;
static char *color_name[]={"R","G", "B"};
static GLfloat *float_val=NULL;

#define FLOAT_LEN	32
char float_str[FLOAT_LEN]="";

menutree mt[]={
	{"Info", 0, NULL,MENU,0},
		{"Fps", 1, &switch_fps, LASTMENU,0},
	{"Render",0,NULL,MENU,0},
		{"Fog",1,NULL,MENU,0},
			{"On/Off",2,&switch_fog,LASTMENU,0},
			{"Color",2, &fog_color,RGB,0},
			{"Density",2, &fog_density_func,FLOAT,0},
			{"Start",2, &fog_start_func,FLOAT,0},
			{"End",2, &fog_end_func,FLOAT,0},
		{"Particles",1,NULL,MENU,0},
			{"Rain",2,&switch_rain,LASTMENU,0},
			{"Snow",2,&switch_snow,LASTMENU,0},
		{"Mode",1,&set_polymode,OPTIONBOX,0},
			{"Auto",2,0,1,0},
			{"Point",2,(void *) GL_POINT,0,0},
			{"Line",2,(void *) GL_LINE,0,0},
			{"Fill",2,(void *) GL_FILL,0,0},
	{"Output", 0, NULL, MENU,0},
		{"Recording", 1, &switch_recording, LASTMENU,0},
	{"Light", 0, NULL, MENU, 0},
/*		{"Choose", 1, NULL, MENU, 0},
			{"0",1,&choose_light,LASTMENUPATH,'0'},
			{"1",1,&choose_light,LASTMENUPATH,'1'},
			{"2",1,&choose_light,LASTMENUPATH,'2'},
			{"3",1,&choose_light,LASTMENUPATH,'3'},
			{"4",1,&choose_light,LASTMENUPATH,'4'},
			{"5",1,&choose_light,LASTMENUPATH,'5'},
			{"6",1,&choose_light,LASTMENUPATH,'6'},
			{"7",1,&choose_light,LASTMENUPATH,'7'},
		{"Action", 1, NULL, MENU, 0},
			{"Switch",2,&switch_Light,LASTMENU,0},
			{"Ambiant",2,NULL,MENU,0},
			{"Diffuse",2,NULL,MENU,0},
			{"sPecular",2,NULL,MENU,0},
			{"Position",2,NULL,MENU,0},
			{"Direction",2,NULL,MENU,0},
*/
	{NULL,0,NULL,0,0}
};

char upchar(char *str) {
	str--;
	while (!(isupper(*++str) || *str==0));
	return *str;
}

void init_menu() {
	int i;
	
	for (i=0; mt[i].name!=NULL; i++) {
		mt[i].key=upchar(mt[i].name);
		printf("key generated : %c\n", mt[i].key);
	}
}

void read_float(char key) {
	int len=strlen(float_str);
	if (len<FLOAT_LEN+1 && (key=='.' || isdigit(key))) {
		float_str[len++]=key;
		float_str[len]='\0';
	}
	printf("current float is : %s\n" , float_str);
}

void run_color(int key, menutree m) {
	key=toupper(key);
	if (active_color<0) {
		if (key=='R' || key=='G' || key=='B') {
			switch (key) {
			case 'R':
				active_color=0;
				break;
			case 'G':
				active_color=1;
				break;
			case 'B':
				active_color=2;
				break;
			}
			printf("active color is %c", key);
		}
	} else {
		printf("now reading new color float");
		if (key!='\n') {
			read_float(key);
			print_string(float_str);
		} else {
			float_val=m.run(NULL);
			float_val[active_color]=(float) atof(float_str);
			active_color=-1;
			float_str[0]='\0';
		}
	}
}

void run_float(int key, menutree m) {
	printf("now reading new float");
	if (key!='\n') {
		read_float(key);
		print_string(float_str);
	} else {
		float_val=m.run(NULL);
		float_val[0]=(float) atof(float_str);
		float_str[0]='\0';
	}
	
}


void run_menu(char key) {
	int i=currmenu+1;
	int lvl=mt[i].lvl;

	if (mt[currmenu].type==RGB) {
		run_color(key, mt[currmenu]);
		printf("color menu selection #%d\n", i);
		return;
	}
	if (mt[currmenu].type==FLOAT) {
		run_float(key, mt[currmenu]);
		printf("float menu selection #%d\n", i);
		return;
	}
	for (; mt[i].name!=NULL && mt[i].lvl>=lvl; i++) {
		if (mt[i].lvl==lvl && mt[i].key==key) {
			printf("menu selection : %c, item #%d\n", key,i);
			if (currmenu!=-1) {
				if (mt[currmenu].type==OPTIONBOX) {
					mt[currmenu].run(mt[i].run);
					break;
				}
			}
			if (mt[i].type!=LASTMENU) {
				currmenu=i;
				printf("current menu is now #%d\n",currmenu );
			}
			if ((mt[i].type==MENU || mt[i].type==LASTMENU) && mt[i].run!=NULL)
				mt[i].run(NULL);
			if (mt[i].type==RGB || mt[i].type==FLOAT)
				float_val=mt[i].run(NULL);
			break;
		}
	}

}

void display_float(char *name, float val) {
	char str[64];
	sprintf(str,"%s : %f   ", name,(double) val);
	print_string(str);
}

void display_string(char *name, char *val) {
    char str[64];
	sprintf(str,"%s : %s_", name, val);
	print_string(str);		
}

void display_rgb() {
	int i;

	if (float_val!=NULL)
		for (i=0; i<3; i++) {
			display_float(color_name[i], float_val[i]);
		}
	else {
		print_string("unknow color, choose R/G/B");
	}
}


void display_menu(int *var) {
	int i=currmenu+1;
	int lvl=mt[i].lvl;
	
	if (mt[currmenu].type==FLOAT) {
		display_string(mt[currmenu].name, float_str);
		return;
	}
	if (mt[currmenu].type==RGB) {
		if (active_color<0)
			display_rgb();
		else
			display_string(color_name[active_color], float_str);
		return;
	}
	for (; mt[i].name!=NULL && mt[i].lvl>=lvl; i++) {
		if (mt[i].lvl==lvl) {
			print_string(mt[i].name);
			print_string(" | ");
		}
	}
}

