#include <GL/gl.h>
#include <GL/glx.h>

#include "gla.h"
#include "o_funcs.h"

#define NB_PARTS    96
#define MAX_COORD	10

static float px[NB_PARTS];
static float py[NB_PARTS];
static float pz[NB_PARTS];

int snow_on=0;
int rain_on=0;

void switch_snow() {
	snow_on=!snow_on;
	if (snow_on)
		rain_on=0;
}

void switch_rain() {
	rain_on=!rain_on;
	if (rain_on)
		snow_on=0;
}

void init_parts() {
	int i; 
	for (i=0; i<NB_PARTS; i++) {
		px[i]=((float) (rand()%1000))/200.0-2.5;
		py[i]=(float) (rand()%1000)/100.0-4.0;
		pz[i]=(float) (rand()%1000)/200.0*(-1.0);
	}
}


void display_snow() {
	
    int i;
	glPushMatrix();
	glLoadIdentity();
	glColor3f(1.0f, 1.0f, 1.0f);
	glBegin(GL_POINTS);
	
    for (i=0; i<NB_PARTS; i++) {
		o_glVertex3f(px[i], py[i], pz[i]);
		o_glVertex3f(px[i]+0.5, py[i]+0.2, pz[i]+0.1);
		o_glVertex3f(px[i]-0.1, py[i]-0.6, pz[i]-0.2);
		py[i]-=0.0005 * (float)win.frametime;
		while (py[i]< (-4.0)) {
			py[i]+=10.0;
			px[i]=((float)(rand()%1000))/200.0-2.5;
			pz[i]=(float) (rand()%1000)/200.0*(-1.0);
		}
		px[i]+=((float)(rand()%1000)/100000)-0.005;
		pz[i]+=((float)(rand()%1000)/100000)-0.005;
	}
	
	glColor3f(1.0, 1.0, 1.0);
	glEnd();
	glPopMatrix();
}

void display_rain() {
	
    int i;
	glPushMatrix();
	glLoadIdentity();
	glColor4f(0.4f, 0.4f, 0.6f, 0.5f);
	glBegin(GL_LINES);
	
    for (i=0; i<NB_PARTS; i++) {
		o_glVertex3f(px[i], py[i]+0.4, pz[i]);
		o_glVertex3f(px[i], py[i], pz[i]);
		py[i]-=0.004 * (float)win.frametime;
		while (py[i]< (-4.0)) {py[i]+=10.0;}
	}
	
	glColor3f(1.0, 1.0, 1.0);
	glEnd();
	glPopMatrix();
}

