#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <sys/types.h>
#include <sys/stat.h>

#include <GL/gl.h>
#include <GL/glx.h>

#include "gla.h"

int recording_on=0;

static GLubyte *image=NULL;
static int image_size=0;
static FILE *outputfile;

static void open_ppmfile() {
/*	if (mkfifo("/tmp/videopipe", 0777)) {
		perror("creation of video pipe failed");
	}
	system("ffmpeg -f ppmpipe -r 20 -b 2096 -i /tmp/videopipe http://127.0.0.1:8090/feed1.ffm < /dev/null &");*/
	if (( outputfile = fopen("/tmp/video-out.ppm", "w")) == NULL) {
		perror("Can't open video recording ouput file\n");
	}
	
	printf("Recording started\n");
}

static void close_ppmfile() {
	if (image!=NULL) {
		free(image);
		image=NULL;
		image_size=0;
		fclose(outputfile);
	}
	printf("Recording stopped\n");
}

void write_ppmfile() {
	if (image_size < win.x*win.y) {
		image_size=win.x*win.y;
		if (image != NULL) {
			free(image);
			image=NULL;
		}
	}
	if (image==NULL)
		image = (GLubyte *) malloc(win.x * win.y * sizeof(GLubyte) * 3);

	glPixelStorei(GL_PACK_ALIGNMENT, 1);
	glReadPixels(0, 0, win.x, win.y, GL_RGB, GL_UNSIGNED_BYTE, image);

	fprintf(outputfile,"P6\n");
	fprintf(outputfile,"# opengl video recorded from gla...\n");
	fprintf(outputfile,"%d %d\n",win.x,win.y);
	fprintf(outputfile,"255\n");

	fwrite(image,sizeof(char), win.x * win.y * 3 * sizeof(GLubyte),outputfile);
}


int switch_recording() {
	recording_on=!recording_on;
	if (recording_on)
		open_ppmfile();
	else
		close_ppmfile();
}

